-----------------------------------------------------------------------------------------------
-- Client Lua Script for FPGun
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "Sound"
 
-----------------------------------------------------------------------------------------------
-- WildBorne Module Definition
-----------------------------------------------------------------------------------------------
local WildBorne = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local displayTimer 

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function WildBorne:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function WildBorne:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
    Apollo.RegisterEventHandler("UI_HealthChanged", "OnDeath", self)
end
 

-----------------------------------------------------------------------------------------------
-- WildBorne OnLoad
-----------------------------------------------------------------------------------------------
function WildBorne:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("WildBorne.xml")
	Apollo.LoadSprites("WBSprite.xml","WBSprite")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- WildBorne OnDocLoaded
-----------------------------------------------------------------------------------------------
function WildBorne:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "DeathScreen", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
          self.wndMain:Show(false)
--          Sound.PlayFile("Sounds\\youdied32.wav")
	end
end

-----------------------------------------------------------------------------------------------
-- WildBorne Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function WildBorne:OnDeath(current, max)
     if current <= 0 then
--          ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "You're dead")
          Sound.PlayFile("Sounds\\youdied32.wav")
          displayTimer = ApolloTimer.Create(4.0, false, "HideScreen", self)
          displayTimer:Start()
          self.wndMain:Show(true,false,2)
     end
end

function WildBorne:HideScreen()
    displayTimer:Stop()
    self.wndMain:Show(false,false,2)
end

-----------------------------------------------------------------------------------------------
-- WildBorneForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function WildBorne:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function WildBorne:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- FPGun Instance
-----------------------------------------------------------------------------------------------
local WildBorneInst = WildBorne:new()
WildBorneInst:Init()
